<p-blockUI [target]="pnl" [blocked]="blockedPanel">
    <i class="pi pi-spin pi-spinner" style="font-size: 3rem"></i>
</p-blockUI>
<div class="grid">
    <div class="col-12">
        <div class="card">
            <h5 class="text-blue-500 font-bold"><i class="pi pi-calendar text-4xl"></i>จัดการ Slot</h5>
            <p-table #pnl [value]="slots" scrollDirection="both" [paginator]="true" [rows]="10" [scrollable]="true"
                [showCurrentPageReport]="true" styleClass="mt-3" responsiveLayout="scroll" [rowHover]="true"
                currentPageReportTemplate="Showing {first} to {last} of {totalRecords} entries"
                [rowsPerPageOptions]="[10,25,50]" [globalFilterFields]="['slot_name','service_name']">
                <ng-template pTemplate="caption">
                    <div class="flex flex-wrap gap-2 align-items-center justify-content-between">
                        <span class="p-input-icon-left w-full sm:w-20rem flex-order-1 sm:flex-order-0">
                            <i class="pi pi-search"></i>
                            <input pInputText type="text" (input)="onGlobalFilter(pnl, $event)" placeholder="ค้นหา"
                                class="w-full" />
                        </span>
                        <button (click)="displayFormAdd()" pButton
                            class="p-button w-full sm:w-auto flex-order-0 sm:flex-order-1"
                            icon="pi pi-plus-circle" label="เพิ่ม Slot"></button>
                    </div>
                </ng-template>
                <ng-template pTemplate="header">
                    <tr>
                        <th class="text-center">ลำดับ</th>
                        <th pSortableColumn="service_name">คลินิก <p-sortIcon field="service_name"></p-sortIcon></th>
                        <th pSortableColumn="service_type_name">บริการ <p-sortIcon field="service_type_name"></p-sortIcon></th>
                        <th pSortableColumn="slot_name">ชื่อสลอต <p-sortIcon field="slot_name"></p-sortIcon></th>
                        <th pSortableColumn="slot_date">วันที่ <p-sortIcon field="slot_date"></p-sortIcon></th>
                        <th pSortableColumn="period_name">ช่วงเวลา <p-sortIcon field="period_name"></p-sortIcon></th>
                        <th class="text-center" pSortableColumn="total_slot_per_period">จำนวน <p-sortIcon field="total_slot_per_period"></p-sortIcon></th>
                        <th class="text-center" pSortableColumn="slot_avialable">เปิด/ปิดสลอต <p-sortIcon field="slot_avialable"></p-sortIcon></th>
                        <th class="text-center" pSortableColumn="is_active">สถานะการใช้งาน <p-sortIcon field="is_active"></p-sortIcon></th>
                        <th class="text-center"></th>
                    </tr>
                </ng-template>
                <ng-template pTemplate="body" let-slot let-i="rowIndex">
                    <tr>
                        <td class="text-center">{{i+1}}</td>
                        <td>{{slot.service_name}}</td>
                        <td>{{slot.service_type_name}}</td>
                        <td>{{slot.slot_name}}</td>
                        <td>{{thaiDateFormat(slot.slot_date)}}</td>
                        <td>{{slot.period_name}}</td>
                        <td class="text-center">{{slot.total_slot_per_period}}</td>  
                        <td class="text-center">
                            <p-tag *ngIf="slot.slot_avialable" severity="success" value="เปิดใช้งาน"></p-tag>
                            <p-tag *ngIf="!slot.slot_avialable" severity="danger" value="ปิดใช้งาน"></p-tag>
                        </td>
                        <td class="text-center">
                            <p-tag *ngIf="slot.is_active" severity="success" value="เปิดใช้งาน"></p-tag>
                            <p-tag *ngIf="!slot.is_active" severity="danger" value="ปิดใช้งาน"></p-tag>
                        </td>
                        <td class="text-center">
                            <button type="button" pButton pRipple icon="pi pi-pencil" class="h-1rem  mr-2 p-button-warning p-button-raised" (click)="displayFormEdit(slot)" pTooltip="แก้ไขข้อมูล" tooltipPosition="bottom"></button>
                        </td>
                </ng-template>
            </p-table>
        </div>
    </div>
    <p-dialog [(visible)]="displayForm" [breakpoints]="{'960px': '75vw', '640px': '100vw'}" [style]="{width: '50vw'}">
        <ng-template pTemplate="header">
            <h5 *ngIf="isAdd">เพิ่มสลอต</h5>            
            <h5 *ngIf="isEdit">แก้ไขสลอต</h5>            
        </ng-template>
        <p-messages [(value)]="messages" [enableService]="false" [closable]="false"></p-messages>
        <ng-template pTemplate="content">
            <div *ngIf="isAdd" class="p-fluid">
                <div class="grid">
                    <div class="col-12 md:col-6">                        
                            <h6>คลินิก</h6>
                            <p-dropdown  [options]="listService" [(ngModel)]="selectedService" optionLabel="service_name" optionValue="service_id" placeholder="Select a Service" (onChange)="selectClinic()"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-6">                      
                            <h6>การให้บริการ</h6>
                            <p-dropdown [options]="listServicetypetemp" [(ngModel)]="selectedServicetype" optionLabel="service_type_name" optionValue="service_type_id"  placeholder="Select a Servicetype"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-6">
                            <h6>ชื่อสลอต</h6>
                            <input type="text" id="slot_name" [(ngModel)]="slot_name" placeholder="ชื่อสลอต" pInputText>                            
                    </div>
                    <div class="col-12 md:col-6">
                            <h6>ช่วงเวลา</h6>
                            <p-dropdown [options]="listPeriods" [(ngModel)]="selectedPeriod" optionLabel="period_name" optionValue="period_id"  placeholder="Select a Servicetype"></p-dropdown>                          
                    </div>
                    <div class="col-12 md:col-6">                        
                            <h6>จำนวนสลอต</h6>
                            <p-inputNumber [(ngModel)]="total_slot_per_period" mode="decimal" inputId="total_slot_per_period" [useGrouping]="false" placeholder="จำนวนสลอต"> </p-inputNumber>                      
                    </div>
                    <div class="col-12 md:col-6">                        
                            <h6>วันที่เปิดสลอต</h6>
                            <p-calendar [(ngModel)]="slot_date" [showIcon]="true" dateFormat="dd/mm/yy"></p-calendar>                      
                    </div>
                    <div class="col-12 md:col-3">                        
                            <h6>การเปิดให้จอง</h6>
                            <p-inputSwitch [(ngModel)]="slot_avialable"></p-inputSwitch>                  
                    </div>
                    <div class="col-12 md:col-3">                        
                            <h6>สถานะ</h6>
                            <p-inputSwitch [(ngModel)]="status_is_active"></p-inputSwitch>             
                    </div>
                </div>
            </div>


            <div *ngIf="isEdit" class="p-fluid">
                <div class="grid">
                    <div class="col-12 md:col-6">                        
                            <h6>คลินิก</h6>
                            <p-dropdown  [options]="listService" [(ngModel)]="selectedService" optionLabel="service_name" optionValue="service_id" placeholder="Select a Service" (onChange)="selectClinic()"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-6">                      
                            <h6>การให้บริการ</h6>
                            <p-dropdown [options]="listServicetypetemp" [(ngModel)]="selectedServicetype" optionLabel="service_type_name" optionValue="service_type_id"  placeholder="Select a Servicetype"></p-dropdown>
                    </div>
                    <div class="col-12 md:col-6">
                            <h6>ชื่อสลอต</h6>
                            <input type="text" id="slot_name" [(ngModel)]="slot_name" placeholder="ชื่อสลอต" pInputText>                            
                    </div>
                    <div class="col-12 md:col-6">
                            <h6>ช่วงเวลา</h6>
                            <p-dropdown [options]="listPeriods" [(ngModel)]="selectedPeriod" optionLabel="period_name" optionValue="period_id"  placeholder="Select a Servicetype"></p-dropdown>                          
                    </div>
                    <div class="col-12 md:col-6">                        
                            <h6>จำนวนสลอต</h6>
                            <p-inputNumber [(ngModel)]="total_slot_per_period" mode="decimal" inputId="total_slot_per_period" [useGrouping]="false" placeholder="จำนวนสลอต"> </p-inputNumber>                      
                    </div>
                    <div class="col-12 md:col-6">                        
                            <h6>วันที่เปิดสลอต</h6>
                            <p-calendar [(ngModel)]="slot_date" [showIcon]="true" dateFormat="dd/mm/yy"></p-calendar>                      
                    </div>
                    <div class="col-12 md:col-3">                        
                            <h6>การเปิดให้จอง</h6>
                            <p-inputSwitch [(ngModel)]="slot_avialable"></p-inputSwitch>                  
                    </div>
                    <div class="col-12 md:col-3">                        
                            <h6>สถานะ</h6>
                            <p-inputSwitch [(ngModel)]="status_is_active"></p-inputSwitch>             
                    </div>
                </div>
            </div>
        </ng-template>
        <ng-template pTemplate="footer">
            <button *ngIf="isAdd" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success"
                (click)="save()" label="เพิ่มรายการ"></button>
            <button *ngIf="isEdit" type="button" pButton icon="pi pi-check" class="p-button-raised p-button-success"
                (click)="update()" label="บันทึกแก้ไข"></button>
        </ng-template>
    </p-dialog>
</div>